from django.shortcuts import render ,redirect
from django.contrib.auth.decorators import login_required
from articles.models import Article
from django.contrib import messages
from lots.models import Lot
from infosachats.models import InfoAchat
from infosventes.models import InfoVente
from historiquearticles.models import HistoriqueArticle
from articlescommandee.models import ArticleCommandee
from articlescommandeefactures.models import Articlescommandeefactures
from django.http import JsonResponse
from django.core import serializers
from core.decorators import allowed_users
from pathlib import Path
from django.core.files import File
import os
#Create your views here.
@login_required(login_url="/login/")
@allowed_users(allowed_roles=['admingestion'])
def formulaire_ajouter_medicament(request):
	context = {}
	context['segment'] = 'articles'
	return render(request, 'ajouter-article.html', context)


@login_required(login_url="/login/")
@allowed_users(allowed_roles=['admingestion'])
def ajouter_article(request):
	context = {}
	if request.method =="POST":
		nom_article = request.POST.get('nom_article')
		user = request.POST.get('user')
		
		image = request.FILES.get('image') 
		seuil_reapprovisionnement = request.POST.get('seuil_reapprovisionnement')
		stock_d_ouverture = request.POST.get('stock_d_ouverture')
		unitee = request.POST.get('unitee')
		retour = request.POST.get('retour')
		if retour != True:
			retour = False
		poids = request.POST.get('poids')


	test_article = Article.objects.filter(nom_article = nom_article ) 
	print("si l article existe ou pas ",test_article.exists())
	if not test_article.exists():
		article = Article(nom_article = nom_article ,image = image, unitee =unitee,  seuil_reapprovisionnement = seuil_reapprovisionnement,stock_d_ouverture = stock_d_ouverture, 
		   stock_comptable_disponible = stock_d_ouverture, quantitee_non_declarer_comme_lot = stock_d_ouverture ,retour = retour , poids= poids )
		article.save()
		historique = HistoriqueArticle(article =article, date = article.created_at, user = user, details = 'crée par')
		historique.save()
		messages.success(request, "l'article a été bien ajouté")
	else:
		messages.error(request, "Article existe déja")

	return render(request, 'ajouter-article.html', context)
@allowed_users(allowed_roles=['admingestion'])
@login_required(login_url="/login/")
def liste_articles(request):
	context = {}
	context['articles'] = Article.objects.all().order_by('created_at').reverse()

	return render(request, 'liste-articles.html', context)


@login_required(login_url="/login/")
def detail_article(request):
	context = {}
	liste_facture = []
	liste_commande = []
	# article_commandee_faturee = []
	if request.method == "POST":
		id_article = request.POST.get('id_article')

	context['article'] = Article.objects.get(id = id_article )
	article_obj = Article.objects.get(id = id_article )
	articlecommandee = ArticleCommandee.objects.filter(article =article_obj )
	
	# for i in articlecommandee:
	# 	if Articlescommandeefactures.objects.filter(articleCommandee = i).exists() :
	# 		article_commandee_faturee.append(Articlescommandeefactures.objects.filter(articleCommandee = i))


	articlecommandee2 = ArticleCommandee.objects.filter(article = article_obj)
	if articlecommandee2.exists() :
		for j in articlecommandee2:
			print('comande ',j)
			if j.commande.type_commande =='commande':
				liste_commande.append(j.commande)

	context['liste_commandes'] = liste_commande
	# context['factures'] = liste_facture
	context['lots'] = Lot.objects.filter(article = id_article)
	context['historiques'] = HistoriqueArticle.objects.filter(article = id_article)

	return render(request, 'detail-article.html', context)
	
@login_required(login_url="/login/")
def afficher_modifier_articles(request):
	context ={}
	if request.method == "POST":
		id_article = request.POST.get('id_article')
		context['article'] = Article.objects.get(id = id_article )
	return render(request, 'modifier-article.html', context)

@login_required(login_url="/login/")
def valider_modifier_articles(request):
	context = {}

	if request.method =="POST":
		id_article = request.POST.get('article')
		nom_article = request.POST.get('nom_article')
		user = request.POST.get('user')
		image = request.FILES.get('image') 
		seuil_reapprovisionnement = request.POST.get('seuil_reapprovisionnement')
		stock_d_ouverture = request.POST.get('stock_d_ouverture')
		stock_comptable_disponible = request.POST.get('stock_comptable_disponible')
		quantitee_non_declarer_comme_lot = request.POST.get('quantitee_non_declarer_comme_lot')

		retour = request.POST.get('retour')
		if retour != True:
			retour = False
		unitee = request.POST.get('unitee')


		Article.objects.filter(id = id_article).update(nom_article = nom_article)	
		Article.objects.filter(id = id_article).update(seuil_reapprovisionnement =seuil_reapprovisionnement )
		Article.objects.filter(id = id_article).update(stock_d_ouverture = stock_d_ouverture )
		Article.objects.filter(id = id_article).update(retour = retour)
		Article.objects.filter(id = id_article).update(unitee = unitee)
		Article.objects.filter(id = id_article).update(stock_comptable_disponible = stock_comptable_disponible)
		Article.objects.filter(id = id_article).update(quantitee_non_declarer_comme_lot = quantitee_non_declarer_comme_lot)


		if image :
			article =Article.objects.get(id = id_article)
			
			# if article.image :
			# 	os.remove(article.image.url)
			article.image = request.FILES['image']  
			article.save()  

		messages.success(request, "l'article a été bien modifier")

	return redirect('liste_articles')

@login_required(login_url="/login/")
def supprimer_article(request):

	if request.method =="POST":
		id_article = request.POST.get('id_article')
		article = Article.objects.get(id = id_article)

		if ArticleCommandee.objects.filter(article = article).exists() :
			messages.info(request, "vous ne pouvez pas supprimer cet article")
		else : 
			article.delete()
			messages.success(request, "l'article  a été bien supprimer")
	return redirect('liste_articles')	
	
# def donnee_medicament(request):
# 	if request.is_ajax and request.method == "GET":
# 		medicament = request.GET.get("medicament", None)
# 		id_medicament = medicament.split()[0]
# 		try:
# 			medicament_object = Medicament.objects.get(id = id_medicament)
# 			ser_instance = serializers.serialize('json', [medicament_object,])
# 			return JsonResponse({"article":False, "instance": ser_instance}, status=200)
# 		except Exception as e:
# 			return JsonResponse({"article":True}, status = 200)
		
		
# 	return JsonResponse({}, status = 400)






